Codeforces Round #419 (Div. 1) C. Karen and Supermarket 树形DP

C. Karen and Supermarket
 
 

On the way home, Karen decided to stop by the supermarket to buy some groceries.

She needs to buy a lot of goods, but since she is a student her budget is still quite limited. In fact, she can only spend up to b dollars.

The supermarket sells n goods. The i-th good can be bought for ci dollars. Of course, each good can only be bought once.

Lately, the supermarket has been trying to increase its business. Karen, being a loyal customer, was given n coupons. If Karen purchases the i-th good, she can use the i-th coupon to decrease its price by di. Of course, a coupon cannot be used without buying the corresponding good.

There is, however, a constraint with the coupons. For all i ≥ 2, in order to use the i-th coupon, Karen must also use the xi-th coupon (which may mean using even more coupons to satisfy the requirement for that coupon).

Karen wants to know the following. What is the maximum number of goods she can buy, without exceeding her budget b?

Input

The first line of input contains two integers n and b (1 ≤ n ≤ 5000, 1 ≤ b ≤ 109), the number of goods in the store and the amount of money Karen has, respectively.

The next n lines describe the items. Specifically:

  • The i-th line among these starts with two integers, ci and di (1 ≤ di < ci ≤ 109), the price of the i-th good and the discount when using the coupon for the i-th good, respectively.
  • If i ≥ 2, this is followed by another integer, xi (1 ≤ xi < i), denoting that the xi-th coupon must also be used before this coupon can be used.
Output

Output a single integer on a line by itself, the number of different goods Karen can buy, without exceeding her budget.

Examples
input
6 16
10 9
10 5 1
12 2 1
20 18 3
10 2 3
2 1 5
output
4
 
Note

In the first test case, Karen can purchase the following 4 items:

  • Use the first coupon to buy the first item for 10 - 9 = 1 dollar.
  • Use the third coupon to buy the third item for 12 - 2 = 10 dollars.
  • Use the fourth coupon to buy the fourth item for 20 - 18 = 2 dollars.
  • Buy the sixth item for 2 dollars.

The total cost of these goods is 15, which falls within her budget. Note, for example, that she cannot use the coupon on the sixth item, because then she should have also used the fifth coupon to buy the fifth item, which she did not do here.

In the second test case, Karen has enough money to use all the coupons and purchase everything.

 题意:

  给你n件商品,

  给出每件商品的 原价和 优惠券,用优惠券前必须使用第x件的优惠券才可以使用当前优惠券

  求b元下,最多买多少件商品

题解:

  暴力转移

  dp[now][x][0/1]表示当前节点now,买x件商品,当前now节点的商品是否使用优惠券的最小花费

  最后check一下就行

  先转移后更新是个优化

#include<bits/stdc++.h>
using namespace std;
#define ls i<<1
#define rs ls | 1
#define mid ((ll+rr)>>1)
#define MP make_pair
typedef long long LL;
const long long INF = 1e18+1LL;
const int N = 5e3+50, mod = 2017, inf = 2e9;

int n,b,c[N],d[N],siz[N],x[N];
LL dp[N][N][2];
vector<int > G[N];
void dfs(int u,int f) {
    siz[u] = 1;
    dp[u][0][0] = 0;
    dp[u][1][0] = c[u];
    dp[u][1][1] = c[u] - d[u];
    for(int i = 0; i < G[u].size(); ++i) {
        int to = G[u][i];
        if(to == f) continue;
        dfs(to,u);
        for(int j = siz[u]; j >= 0; --j) {
            for(int k = siz[to]; k >= 0; --k) {
                dp[u][j+k][0] = min(dp[u][j+k][0], dp[u][j][0] + dp[to][k][0]);
                dp[u][j+k][1] = min(dp[u][j+k][1], dp[u][j][1] + min(dp[to][k][0],dp[to][k][1]));
            }
        }
        siz[u] += siz[to];
    }
}
int main() {
    scanf("%d%d",&n,&b);
    scanf("%d%d",&c[1],&d[1]);
    for(int i = 2; i <= n; ++i) {
        scanf("%d%d%d",&c[i],&d[i],&x[i]);
        G[x[i]].push_back(i);
    }
    for(int i = 1; i <= n; ++i)
        for(int j = 0; j <= n; ++j) {
            dp[i][j][0] = INF;
            dp[i][j][1] = INF;
        }
    dfs(1,0);
    int ans = 0;
    for(int i = 1; i <= n; ++i)
        if(min(dp[1][i][0],dp[1][i][1]) <= b) ans = i;
    printf("%d
",ans);
    return 0;
}
原文地址:https://www.cnblogs.com/zxhl/p/7058982.html